#ifndef __saw_h__
#define __saw_h__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <limits.h>
#include <string.h>

#define MAXN 20           /* maximum length of a walk */

#define MAXSITES  100000  /* maximum allowed site nr */
#define MAXNODES  80000000 /* maximum allowed number of nodes in a tree */

#define TRUE 1
#define FALSE 0
#define GIGA 1000000000 
#define ROOT -2
#define DUMMY -1
#define ALPHA 0.5

#define NCHUNKS 5  /* Total number of decimal digits of a very long integer
                      printed on output is up to 9*NCHUNKS.
                      This can handle a 128-bit integer. */

/* Wrappers for integers, making it easy to change the size of integers.
   Site numbers are small, and regular int is sufficient for them */

    typedef long       cint ;  /* count integer */
    typedef __int128_t ccint ; /* integer for squared counts, works only in gcc,
                                 otherwise use long long int  */
    typedef long       nint ;  /* node integer */

#endif /* __saw_h__ */

