#ifndef __sawdoubler_h__
#define __sawdoubler_h__

#include "symmetry.h"

typedef struct zzout {
    ccint Z ; /* SAW count given as output */
    ccint RR ; /* sum of squared Euclidean norm given as output */
} ZZout ;

typedef struct bin {
    nint First ;  /* first node in the bin */
    nint Stamp;   /* time stamp of the bin*/
} Bin ;

/* Function declarations */
void InitTree(struct treenode *Nodes, nint *nodes) ;
int AddWalkToTree(int *Walk, int N, int ctype, struct gridpoint endpoint, 
                   struct treenode *Nodes, nint *nodes) ;
int FilterSort_Walk(int *Walk, int N, int *Term, int nt, int a, int b, int c) ;
void InsertionSort(int *A, int N) ;
struct zzout Correct(struct treenode *Nodes, int N, int countop, int *S, int ns, 
              int symmS, nint *nincludes,
              struct bin *Bins, int maxbin,
              struct vertex *V, int *lattice, int *rl,
              int a, int b, int c) ;
void InitBins(struct treenode *Nodes, nint nodes,
              struct bin *Bins, int *maxbin) ;
void InsertInBin(struct treenode *Nodes, struct bin *Bins, nint i, nint stamp) ;
void print_verylong(FILE *fp, ccint Z) ;

#endif /* __sawdoubler_h__ */
